Index: atari_chips/pokeyv2/flash_08/flash/synthesis/flash.qip
===================================================================
--- atari_chips/pokeyv2/flash_08/flash/synthesis/flash.qip	(revision 1421)
+++ atari_chips/pokeyv2/flash_08/flash/synthesis/flash.qip	(revision 1422)
@@ -1,8 +1,8 @@
 set_global_assignment -entity "flash" -library "flash" -name IP_TOOL_NAME "Qsys"
-set_global_assignment -entity "flash" -library "flash" -name IP_TOOL_VERSION "20.1"
+set_global_assignment -entity "flash" -library "flash" -name IP_TOOL_VERSION "23.1"
 set_global_assignment -entity "flash" -library "flash" -name IP_TOOL_ENV "Qsys"
 set_global_assignment -library "flash" -name SOPCINFO_FILE [file join $::quartus(qip_path) "../../flash.sopcinfo"]
-set_global_assignment -entity "flash" -library "flash" -name SLD_INFO "QSYS_NAME flash HAS_SOPCINFO 1 GENERATION_ID 1610543004"
+set_global_assignment -entity "flash" -library "flash" -name SLD_INFO "QSYS_NAME flash HAS_SOPCINFO 1 GENERATION_ID 1725106633"
 set_global_assignment -library "flash" -name MISC_FILE [file join $::quartus(qip_path) "../flash.cmp"]
 set_global_assignment -library "flash" -name SLD_FILE [file join $::quartus(qip_path) "flash.debuginfo"]
 set_global_assignment -entity "flash" -library "flash" -name IP_TARGETED_DEVICE_FAMILY "MAX 10"
@@ -15,7 +15,7 @@
 set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_REPORT_HIERARCHY "On"
 set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_INTERNAL "Off"
 set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_VERSION "MS4w"
-set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_PARAMETER "QVVUT19HRU5FUkFUSU9OX0lE::MTYxMDU0MzAwNA==::QXV0byBHRU5FUkFUSU9OX0lE"
+set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_PARAMETER "QVVUT19HRU5FUkFUSU9OX0lE::MTcyNTEwNjYzMw==::QXV0byBHRU5FUkFUSU9OX0lE"
 set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_PARAMETER "QVVUT19ERVZJQ0VfRkFNSUxZ::TUFYIDEw::QXV0byBERVZJQ0VfRkFNSUxZ"
 set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_PARAMETER "QVVUT19ERVZJQ0U=::MTBNMDhTQ1UxNjlDOEc=::QXV0byBERVZJQ0U="
 set_global_assignment -entity "flash" -library "flash" -name IP_COMPONENT_PARAMETER "QVVUT19ERVZJQ0VfU1BFRURHUkFERQ==::OA==::QXV0byBERVZJQ0VfU1BFRURHUkFERQ=="
@@ -28,11 +28,11 @@
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_REPORT_HIERARCHY "Off"
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_INTERNAL "Off"
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_AUTHOR "QWx0ZXJhIENvcnBvcmF0aW9u"
-set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_VERSION "MjAuMQ=="
+set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_VERSION "MjMuMQ=="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_DESCRIPTION "QWx0ZXJhIE9uLUNoaXAgRmxhc2ggTWVnYWZ1bmN0aW9uIHdpdGggQXZhbG9uLU1NIFNsYXZlIEludGVyZmFjZS4="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "REFUQV9JTlRFUkZBQ0U=::UGFyYWxsZWw=::RGF0YSBpbnRlcmZhY2U="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "UkVBRF9CVVJTVF9NT0RF::V3JhcHBpbmc=::UmVhZCBidXJzdCBtb2Rl"
-set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "Q0xPQ0tfRlJFUVVFTkNZ::ODAuMA==::Q2xvY2sgZnJlcXVlbmN5"
+set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "Q0xPQ0tfRlJFUVVFTkNZ::MTE2LjA=::Q2xvY2sgZnJlcXVlbmN5"
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "Q09ORklHVVJBVElPTl9NT0RF::U2luZ2xlIFVuY29tcHJlc3NlZCBJbWFnZQ==::Q29uZmlndXJhdGlvbiBNb2Rl"
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "U0VDVE9SX0FDQ0VTU19NT0RF::UmVhZCBhbmQgd3JpdGUsUmVhZCBhbmQgd3JpdGUsUmVhZCBvbmx5LFJlYWQgYW5kIHdyaXRlLFJlYWQgYW5kIHdyaXRl::QWNjZXNzIE1vZGU="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "aW5pdEZsYXNoQ29udGVudA==::ZmFsc2U=::SW5pdGlhbGl6ZSBmbGFzaCBjb250ZW50"
@@ -70,10 +70,10 @@
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfU0VRX1JFQURfREFUQV9DT1VOVA==::Mg==::RkxBU0hfU0VRX1JFQURfREFUQV9DT1VOVA=="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfQUREUl9BTElHTk1FTlRfQklUUw==::MQ==::RkxBU0hfQUREUl9BTElHTk1FTlRfQklUUw=="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfUkVBRF9DWUNMRV9NQVhfSU5ERVg=::NA==::RkxBU0hfUkVBRF9DWUNMRV9NQVhfSU5ERVg="
-set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfUkVTRVRfQ1lDTEVfTUFYX0lOREVY::MjA=::RkxBU0hfUkVTRVRfQ1lDTEVfTUFYX0lOREVY"
-set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfQlVTWV9USU1FT1VUX0NZQ0xFX01BWF9JTkRFWA==::OTY=::RkxBU0hfQlVTWV9USU1FT1VUX0NZQ0xFX01BWF9JTkRFWA=="
-set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfRVJBU0VfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg=::MjgwMDAwMDA=::RkxBU0hfRVJBU0VfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg="
-set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfV1JJVEVfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg=::MjQ0MDA=::RkxBU0hfV1JJVEVfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg="
+set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfUkVTRVRfQ1lDTEVfTUFYX0lOREVY::Mjk=::RkxBU0hfUkVTRVRfQ1lDTEVfTUFYX0lOREVY"
+set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfQlVTWV9USU1FT1VUX0NZQ0xFX01BWF9JTkRFWA==::MTM5::RkxBU0hfQlVTWV9USU1FT1VUX0NZQ0xFX01BWF9JTkRFWA=="
+set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfRVJBU0VfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg=::NDA2MDAwMDA=::RkxBU0hfRVJBU0VfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg="
+set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "RkxBU0hfV1JJVEVfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg=::MzUzODA=::RkxBU0hfV1JJVEVfVElNRU9VVF9DWUNMRV9NQVhfSU5ERVg="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "UEFSQUxMRUxfTU9ERQ==::dHJ1ZQ==::UEFSQUxMRUxfTU9ERQ=="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "UkVBRF9BTkRfV1JJVEVfTU9ERQ==::dHJ1ZQ==::UkVBRF9BTkRfV1JJVEVfTU9ERQ=="
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_COMPONENT_PARAMETER "V1JBUFBJTkdfQlVSU1RfTU9ERQ==::dHJ1ZQ==::V1JBUFBJTkdfQlVSU1RfTU9ERQ=="
@@ -90,5 +90,5 @@
 set_global_assignment -library "flash" -name VERILOG_FILE [file join $::quartus(qip_path) "submodules/rtl/altera_onchip_flash_block.v"]
 
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_TOOL_NAME "altera_onchip_flash"
-set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_TOOL_VERSION "20.1"
+set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_TOOL_VERSION "23.1"
 set_global_assignment -entity "altera_onchip_flash" -library "flash" -name IP_TOOL_ENV "Qsys"
Index: atari_chips/pokeyv2/flash_08/flash/synthesis/flash.vhd
===================================================================
--- atari_chips/pokeyv2/flash_08/flash/synthesis/flash.vhd	(revision 1421)
+++ atari_chips/pokeyv2/flash_08/flash/synthesis/flash.vhd	(revision 1422)
@@ -1,6 +1,6 @@
 -- flash.vhd
 
--- Generated using ACDS version 20.1 720
+-- Generated using ACDS version 23.1 993
 
 library IEEE;
 use IEEE.std_logic_1164.all;
@@ -135,10 +135,10 @@
 			FLASH_SEQ_READ_DATA_COUNT           => 2,
 			FLASH_ADDR_ALIGNMENT_BITS           => 1,
 			FLASH_READ_CYCLE_MAX_INDEX          => 4,
-			FLASH_RESET_CYCLE_MAX_INDEX         => 20,
-			FLASH_BUSY_TIMEOUT_CYCLE_MAX_INDEX  => 96,
-			FLASH_ERASE_TIMEOUT_CYCLE_MAX_INDEX => 28000000,
-			FLASH_WRITE_TIMEOUT_CYCLE_MAX_INDEX => 24400,
+			FLASH_RESET_CYCLE_MAX_INDEX         => 29,
+			FLASH_BUSY_TIMEOUT_CYCLE_MAX_INDEX  => 139,
+			FLASH_ERASE_TIMEOUT_CYCLE_MAX_INDEX => 40600000,
+			FLASH_WRITE_TIMEOUT_CYCLE_MAX_INDEX => 35380,
 			PARALLEL_MODE                       => true,
 			READ_AND_WRITE_MODE                 => true,
 			WRAPPING_BURST_MODE                 => true,
Index: atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash.sdc
===================================================================
--- atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash.sdc	(revision 1421)
+++ atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash.sdc	(revision 1422)
@@ -1,4 +1,4 @@
-# (C) 2001-2020 Intel Corporation. All rights reserved.
+# (C) 2001-2024 Intel Corporation. All rights reserved.
 # Your use of Intel Corporation's design tools, logic functions and other 
 # software and tools, and its AMPP partner logic functions, and any output 
 # files from any of the foregoing (including device programming or simulation 
Index: atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash.v
===================================================================
--- atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash.v	(revision 1421)
+++ atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash.v	(revision 1422)
@@ -1,4 +1,4 @@
-// (C) 2001-2020 Intel Corporation. All rights reserved.
+// (C) 2001-2024 Intel Corporation. All rights reserved.
 // Your use of Intel Corporation's design tools, logic functions and other 
 // software and tools, and its AMPP partner logic functions, and any output 
 // files from any of the foregoing (including device programming or simulation 
Index: atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash_avmm_data_controller.v
===================================================================
--- atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash_avmm_data_controller.v	(revision 1421)
+++ atari_chips/pokeyv2/flash_08/flash/synthesis/submodules/altera_onchip_flash_avmm_data_controller.v	(revision 1422)
@@ -1,4 +1,4 @@
-// (C) 2001-2020 Intel Corporation. All rights reserved.
+// (C) 2001-2024 Intel Corporation. All rights reserved.
 // Your use of Intel Corporation's design tools, logic functions and other 
 // software and tools, and its AMPP partner logic functions, and any output 
 // files from any of the foregoing (including device programming or simulation 
@@ -330,8 +330,8 @@
     generate // generate combi based on read burst mode
         if (WRAPPING_BURST_MODE == 0) begin
             // incrementing read
-	    //assign flash_read_addr = (is_read_busy) ? flash_seq_read_ardin : avmm_addr;
-            assign flash_read_addr = avmm_addr; // intel ufm read bug fix 'Is there a known issue with the MAX 10 On Chip Flash IP, for UFM read operations?'
+            assign flash_read_addr = (is_read_busy) ? flash_seq_read_ardin : avmm_addr;
+            //assign flash_read_addr = avmm_addr; // intel ufm read bug fix 'Is there a known issue with the MAX 10 On Chip Flash IP, for UFM read operations?'
             assign cur_e_addr = csr_sector_erase_addr;
             assign cur_a_addr = (valid_csr_erase) ? csr_page_erase_addr : flash_read_addr;
             assign flash_arclk_arshft_en_w = (~is_erase_busy && ~is_write_busy && ~is_read_busy && valid_command) || (is_read_busy && (read_state == READ_STATE_FINAL || read_state == READ_STATE_ADDR));
Index: atari_chips/pokeyv2/flash_08/flash.sopcinfo
===================================================================
--- atari_chips/pokeyv2/flash_08/flash.sopcinfo	(revision 1421)
+++ atari_chips/pokeyv2/flash_08/flash.sopcinfo	(revision 1422)
@@ -1,11 +1,11 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <EnsembleReport name="flash" kind="flash" version="1.0" fabric="QSYS">
- <!-- Format version 20.1 720 (Future versions may contain additional information.) -->
- <!-- 2021.01.13.13:51:58 -->
+ <!-- Format version 23.1 993 (Future versions may contain additional information.) -->
+ <!-- 2024.08.31.14:17:13 -->
  <!-- A collection of modules and connections -->
  <parameter name="AUTO_GENERATION_ID">
   <type>java.lang.Integer</type>
-  <value>1610542318</value>
+  <value>1725106633</value>
   <derived>false</derived>
   <enabled>true</enabled>
   <visible>false</visible>
@@ -98,7 +98,7 @@
  <module
    name="onchip_flash_0"
    kind="altera_onchip_flash"
-   version="20.1"
+   version="23.1"
    path="onchip_flash_0">
   <!-- Describes a single module. Module parameters are
 the requested settings for a module instance. -->
@@ -735,7 +735,7 @@
    <visible>true</visible>
    <valid>true</valid>
   </parameter>
-  <interface name="clk" kind="clock_sink" version="20.1">
+  <interface name="clk" kind="clock_sink" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -796,7 +796,7 @@
     <role>clk</role>
    </port>
   </interface>
-  <interface name="nreset" kind="reset_sink" version="20.1">
+  <interface name="nreset" kind="reset_sink" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -841,7 +841,7 @@
     <role>reset_n</role>
    </port>
   </interface>
-  <interface name="data" kind="avalon_slave" version="20.1">
+  <interface name="data" kind="avalon_slave" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -1224,7 +1224,7 @@
     <role>burstcount</role>
    </port>
   </interface>
-  <interface name="csr" kind="avalon_slave" version="20.1">
+  <interface name="csr" kind="avalon_slave" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -1596,7 +1596,7 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IModule</subtype>
   <displayName>On-Chip Flash Intel FPGA IP</displayName>
-  <version>20.1</version>
+  <version>23.1</version>
  </plugin>
  <plugin>
   <instanceCount>1</instanceCount>
@@ -1604,7 +1604,7 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IMutableConnectionPoint</subtype>
   <displayName>Clock Input</displayName>
-  <version>20.1</version>
+  <version>23.1</version>
  </plugin>
  <plugin>
   <instanceCount>1</instanceCount>
@@ -1612,7 +1612,7 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IMutableConnectionPoint</subtype>
   <displayName>Reset Input</displayName>
-  <version>20.1</version>
+  <version>23.1</version>
  </plugin>
  <plugin>
   <instanceCount>2</instanceCount>
@@ -1620,8 +1620,8 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IMutableConnectionPoint</subtype>
   <displayName>Avalon Memory Mapped Slave</displayName>
-  <version>20.1</version>
+  <version>23.1</version>
  </plugin>
- <reportVersion>20.1 720</reportVersion>
+ <reportVersion>23.1 993</reportVersion>
  <uniqueIdentifier></uniqueIdentifier>
 </EnsembleReport>
Index: atari_chips/pokeyv2/flash_16/flash/synthesis/flash.debuginfo
===================================================================
--- atari_chips/pokeyv2/flash_16/flash/synthesis/flash.debuginfo	(revision 1421)
+++ atari_chips/pokeyv2/flash_16/flash/synthesis/flash.debuginfo	(revision 1422)
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<EnsembleReport name="flash" kind="system" version="19.1" fabric="QSYS">
- <!-- Format version 19.1 670 (Future versions may contain additional information.) -->
- <!-- 2020.11.14.09:21:06 -->
+<EnsembleReport name="flash" kind="system" version="23.1" fabric="QSYS">
+ <!-- Format version 23.1 993 (Future versions may contain additional information.) -->
+ <!-- 2024.08.31.14:38:21 -->
  <!-- A collection of modules and connections -->
  <parameter name="clockCrossingAdapter">
   <type>com.altera.sopcmodel.ensemble.EClockAdapter</type>
@@ -53,7 +53,7 @@
  </parameter>
  <parameter name="generationId">
   <type>int</type>
-  <value>1605342065</value>
+  <value>1725107901</value>
   <derived>false</derived>
   <enabled>true</enabled>
   <visible>true</visible>
@@ -150,7 +150,7 @@
  <module
    name="onchip_flash_0"
    kind="altera_onchip_flash"
-   version="19.1"
+   version="23.1"
    path="onchip_flash_0">
   <!-- Describes a single module. Module parameters are
 the requested settings for a module instance. -->
@@ -787,7 +787,7 @@
    <visible>true</visible>
    <valid>true</valid>
   </parameter>
-  <interface name="clk" kind="clock_sink" version="19.1">
+  <interface name="clk" kind="clock_sink" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -848,7 +848,7 @@
     <role>clk</role>
    </port>
   </interface>
-  <interface name="nreset" kind="reset_sink" version="19.1">
+  <interface name="nreset" kind="reset_sink" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -893,7 +893,7 @@
     <role>reset_n</role>
    </port>
   </interface>
-  <interface name="data" kind="avalon_slave" version="19.1">
+  <interface name="data" kind="avalon_slave" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -1276,7 +1276,7 @@
     <role>burstcount</role>
    </port>
   </interface>
-  <interface name="csr" kind="avalon_slave" version="19.1">
+  <interface name="csr" kind="avalon_slave" version="23.1">
    <!-- The connection points exposed by a module instance for the
 particular module parameters. Connection points and their
 parameters are a RESULT of the module parameters. -->
@@ -1648,7 +1648,7 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IModule</subtype>
   <displayName>On-Chip Flash Intel FPGA IP</displayName>
-  <version>19.1</version>
+  <version>23.1</version>
  </plugin>
  <plugin>
   <instanceCount>1</instanceCount>
@@ -1656,7 +1656,7 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IMutableConnectionPoint</subtype>
   <displayName>Clock Input</displayName>
-  <version>19.1</version>
+  <version>23.1</version>
  </plugin>
  <plugin>
   <instanceCount>1</instanceCount>
@@ -1664,7 +1664,7 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IMutableConnectionPoint</subtype>
   <displayName>Reset Input</displayName>
-  <version>19.1</version>
+  <version>23.1</version>
  </plugin>
  <plugin>
   <instanceCount>2</instanceCount>
@@ -1672,8 +1672,8 @@
   <type>com.altera.entityinterfaces.IElementClass</type>
   <subtype>com.altera.entityinterfaces.IMutableConnectionPoint</subtype>
   <displayName>Avalon Memory Mapped Slave</displayName>
-  <version>19.1</version>
+  <version>23.1</version>
  </plugin>
- <reportVersion>19.1 670</reportVersion>
- <uniqueIdentifier>F44D30F4F5CE00000175C5D7F57C</uniqueIdentifier>
+ <reportVersion>23.1 993</reportVersion>
+ <uniqueIdentifier>02424E4C123F00000191A87192A2</uniqueIdentifier>
 </EnsembleReport>
Index: atari_chips/pokeyv2/flash_16/flash/synthesis/submodules/altera_onchip_flash.sdc
===================================================================
--- atari_chips/pokeyv2/flash_16/flash/synthesis/submodules/altera_onchip_flash.sdc	(revision 1421)
+++ atari_chips/pokeyv2/flash_16/flash/synthesis/submodules/altera_onchip_flash.sdc	(revision 1422)
@@ -1,4 +1,4 @@
-# (C) 2001-2019 Intel Corporation. All rights reserved.
+# (C) 2001-2024 Intel Corporation. All rights reserved.
 # Your use of Intel Corporation's design tools, logic functions and other 
 # software and tools, and its AMPP partner logic functions, and any output 
 # files from any of the foregoing (including device programming or simulation 
Index: atari_chips/pokeyv2/flash_16/flash/synthesis/submodules/altera_onchip_flash_avmm_data_controller.v
===================================================================
--- atari_chips/pokeyv2/flash_16/flash/synthesis/submodules/altera_onchip_flash_avmm_data_controller.v	(revision 1421)
+++ atari_chips/pokeyv2/flash_16/flash/synthesis/submodules/altera_onchip_flash_avmm_data_controller.v	(revision 1422)
@@ -1,4 +1,4 @@
-// (C) 2001-2019 Intel Corporation. All rights reserved.
+// (C) 2001-2024 Intel Corporation. All rights reserved.
 // Your use of Intel Corporation's design tools, logic functions and other 
 // software and tools, and its AMPP partner logic functions, and any output 
 // files from any of the foregoing (including device programming or simulation 
@@ -217,7 +217,6 @@
     reg flash_drdin_neg_reg;
     reg [15:0] write_count;
     reg [25:0] erase_count;
-    reg [2:0] read_count;
     reg [2:0] read_ctrl_count;
     reg [2:0] data_count;
     reg write_timeout;
@@ -331,8 +330,8 @@
     generate // generate combi based on read burst mode
         if (WRAPPING_BURST_MODE == 0) begin
             // incrementing read
-            //assign flash_read_addr = (is_read_busy) ? flash_seq_read_ardin : avmm_addr;
-            assign flash_read_addr = avmm_addr; // intel ufm read bug fix 'Is there a known issue with the MAX 10 On Chip Flash IP, for UFM read operations?'
+            assign flash_read_addr = (is_read_busy) ? flash_seq_read_ardin : avmm_addr;
+            //assign flash_read_addr = avmm_addr; // intel ufm read bug fix 'Is there a known issue with the MAX 10 On Chip Flash IP, for UFM read operations?'
             assign cur_e_addr = csr_sector_erase_addr;
             assign cur_a_addr = (valid_csr_erase) ? csr_page_erase_addr : flash_read_addr;
             assign flash_arclk_arshft_en_w = (~is_erase_busy && ~is_write_busy && ~is_read_busy && valid_command) || (is_read_busy && (read_state == READ_STATE_FINAL || read_state == READ_STATE_ADDR));
@@ -422,7 +421,6 @@
         reset_n_reg2 = 0;
         read_wait = 0;
         read_wait_neg = 0;
-        read_count = 0;
         is_sector1_writable_reg = 0;
         is_sector2_writable_reg = 0;
         is_sector3_writable_reg = 0;
@@ -599,6 +597,7 @@
                 if (~reset_n_w) begin
                     write_state <= WRITE_STATE_IDLE;
                     write_wait <= 0;
+                    csr_status_w_pass <= 1'b0;
                 end
                 else begin
                     case (write_state)
@@ -614,6 +613,7 @@
                                 if (~valid_csr_erase && ~is_erase_busy && ~is_read_busy) begin
                                     write_state <= WRITE_STATE_ADDR;
                                     write_wait <= 1;
+                                    csr_status_w_pass <= 1'b0;
                                 end
                             end
                         end
@@ -723,6 +723,7 @@
             always @ (posedge clock) begin
                 if (~reset_n_w) begin
                     erase_state <= ERASE_STATE_IDLE;
+                    csr_status_e_pass <= 1'b0;
                 end
                 else begin
                     case (erase_state)
@@ -736,6 +737,7 @@
                             // check command
                             if (valid_csr_erase && ~is_write_busy && ~is_read_busy) begin
                                 erase_state <= ERASE_STATE_ADDR;
+                                csr_status_e_pass <= 1'b0;
                             end
                         end
 
@@ -829,6 +831,7 @@
                 if (~reset_n_w) begin
                     read_state <= READ_STATE_IDLE;
                     read_wait <= 0;
+                    csr_status_r_pass <= 0;
                 end
                 else begin
                     case (read_state)
@@ -851,6 +854,7 @@
                                     read_state <= READ_STATE_ADDR;
                                     flash_seq_read_ardin <= avmm_addr;
                                     avmm_burstcount_input_reg <= avmm_burstcount;
+                                    csr_status_r_pass <= 0;
                                 end
                             end
                         end
@@ -940,10 +944,14 @@
             // -------------------------------------------------------------------
             // Avalon_MM data interface fsm - communicate between Avalon_MM and Flash IP (Wrapping Burst Read Operation)
             // -------------------------------------------------------------------        
+            
+            reg [2:0] read_count;
+            
             always @ (posedge clock) begin
                 if (~reset_n_w) begin
                     read_state <= READ_STATE_IDLE;
                     read_wait <= 0;
+                    read_count <= 3'd0;
                 end
                 else begin
                     case (read_state)
Index: atari_chips/pokeyv2/lvds_rx.bsf
===================================================================
--- atari_chips/pokeyv2/lvds_rx.bsf	(revision 1421)
+++ atari_chips/pokeyv2/lvds_rx.bsf	(revision 1422)
@@ -4,7 +4,7 @@
 the Block Editor! File corruption is VERY likely to occur.
 */
 /*
-Copyright (C) 2020  Intel Corporation. All rights reserved.
+Copyright (C) 2024  Intel Corporation. All rights reserved.
 Your use of Intel Corporation's design tools, logic functions 
 and other software and tools, and any partner logic 
 functions, and any output files from any of the foregoing 
Index: atari_chips/pokeyv2/lvds_tx.sip
===================================================================
--- atari_chips/pokeyv2/lvds_tx.sip	(revision 1421)
+++ atari_chips/pokeyv2/lvds_tx.sip	(revision 1422)
@@ -1,7 +1,7 @@
 set_global_assignment -entity "lvds_tx" -library "lib_lvds_tx" -name IP_TOOL_NAME "altera_soft_lvds"
-set_global_assignment -entity "lvds_tx" -library "lib_lvds_tx" -name IP_TOOL_VERSION "20.1"
+set_global_assignment -entity "lvds_tx" -library "lib_lvds_tx" -name IP_TOOL_VERSION "23.1"
 set_global_assignment -entity "lvds_tx" -library "lib_lvds_tx" -name IP_TOOL_ENV "mwpim"
 set_global_assignment -library "lib_lvds_tx" -name SPD_FILE [file join $::quartus(sip_path) "lvds_tx.spd"]
 
 set_global_assignment -library "lib_lvds_tx" -name MISC_FILE [file join $::quartus(sip_path) "lvds_tx_sim/lvds_tx.vhd"]
-set_global_assignment -library "lib_lvds_tx" -name MISC_FILE [file join $::quartus(sip_path) "lvds_tx_sim/altera_soft_lvds/altera_soft_lvds_tx_twD5CSXW.v"]
+set_global_assignment -library "lib_lvds_tx" -name MISC_FILE [file join $::quartus(sip_path) "lvds_tx_sim/altera_soft_lvds/altera_soft_lvds_tx_uCmMXfGB.v"]
